(* moodul TopoLopp teostab sammsammulist lbimngu topoloogilise jrjestuse leidmiseks lppjrjestuse abil *) 

open Struktuurid;;
open AlgoBaas;;

let sygavutiTipud = ref([]);;

(* funktsioon, mis lbib graafi sgavuti lppjrjestuses seni, kuni kik tipud on klastatud, alustades vajadused nullise *)
(* sisendastmega tippudest uuesti. Vajalik Kosaraju ja TopoLopp jaoks. Tagastatakse tekkinud jrjestus *)
let l2biSygavuti(algtipp, tipud, servad) =
	let sygavutiTipud = ref([]) in
	let esimeneTipp = ref(algtipp) in
	!esimeneTipp.tv := Vaatlemata;	(* he tipuga juhuks, muidu ei tta (sest alguses mrkisime algtipu juba valituks) *)
	while List.exists (fun t -> !(t.tv) = Vaatlemata) tipud (* kuniks leidub veel vaatlemata tippe *)
		do
			i := Algus;	(* lbime graafi sgavuti lppjrjestuses alates tipust esimeneTipp *)
			algoL2bi := false;
			SygavutiLopp.toodeldudTipud := [];
			while !algoL2bi = false
				do
					SygavutiLopp.samm(!esimeneTipp, tipud, servad)									(*lbime sgavuti*)
				done;
  		sygavutiTipud := !sygavutiTipud @ !(SygavutiLopp.toodeldudTipud); 	(*lisame jrjestusse*)
  		if List.exists (fun t -> !(t.tv) = Vaatlemata) tipud 								(* kui leidub veel vaatlemata tippe *)
  			then esimeneTipp := TopoKahn.valiTipp(tipud) 											(* mrame uue algtipu (sisendastmega 0) *)
  	done;
		algoL2bi := false;
		nk2 := "";
		nk3 := "";
		!sygavutiTipud;;

(* algoritmi algus, mille kigus mrame igale tipule sgavuti lbimise jaoks sisendastme *)
let algus(tipud, servad) =
	List.iter (fun t -> TopoKahn.uuendaSisendastet (TopoKahn.leiaSisendaste(t, servad)) t) tipud;
	tekst := "Algoritm opoloogilise jrjestuse leidmiseks lppjrjestuse kaudu alustab valitud tipust. ";
	i := SygavutiL2bimine;;

(* graafi sgavuti lppjrjestuses lbimine ja tekkinud jrjestuse saamine *)
let sygavutiL2bimine(algtipp, tipud, servad) =	
	sygavutiTipud := l2biSygavuti(algtipp, tipud, servad);
	nk1 := "Lppjrjestus: " ^ string_of_tipud(!sygavutiTipud);
	nk2 := "";
	tekst := "Lbime graafi sgavuti lppjrjestuses.";
	i := Tagurpidi;;

(* tekkinud lppjrjestuse tagurpidi keeramine *)
let tagurpidi() =
	tekst := "Topoloogilise jrjestuse leidmiseks keerame tekkinud jrjestuse tagurpidi.";
	nk1 := "Lpprjestus: " ^ string_of_tipud(!sygavutiTipud);
	nk2 := "Tagurpidi lppjrjestus: " ^ string_of_tipud(List.rev !sygavutiTipud);
	i := Lopp;;

(* algoritmi lpp *)
let lopp() =
	tekst := "Algoritm lpetab, olles leidnud graafi topoloogilise jrjestuse.";
	nk1 := "Topoloogiline jrjestus: " ^ string_of_tipud(List.rev !sygavutiTipud);
	nk2 := "";
	AlgoBaas.lopp();;

(* algoritmi samm *)
let samm(algtipp, tipud, servad) = 
	match !i with
		| Algus -> algus(tipud, servad);
		| SygavutiL2bimine -> sygavutiL2bimine(algtipp, tipud, servad);
		| Tagurpidi -> tagurpidi();
		| Lopp -> lopp();
		| _ -> ();;

